"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const generateExternalRoutesConfig_1 = __importDefault(require("./generateExternalRoutesConfig"));
const generateAppFiles_1 = __importDefault(require("./generateAppFiles"));
const writeFile_1 = __importDefault(require("./utils/writeFile"));
const handleCommandFlags_1 = __importDefault(require("./handleCommandFlags"));
const generate = (config, commandFlags) => {
    handleCommandFlags_1.default(commandFlags);
    const { apps } = config;
    const filesToWrite = generateFilesToWrite(apps);
    filesToWrite.forEach(writeFile_1.default);
};
const generateFilesToWrite = (apps) => {
    const mainAppFiles = Object.entries(apps).map(([appName, appConfig]) => generateAppFiles_1.default(appName, appConfig));
    const otherApps = generateExternalRoutesConfig_1.default(apps);
    const otherAppFiles = Object.entries(otherApps).map(([appName, appConfig]) => generateAppFiles_1.default(appName, appConfig));
    return [...mainAppFiles, ...otherAppFiles].flat();
};
exports.default = generate;
//# sourceMappingURL=generate.js.map