"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const generateTemplateFiles_1 = __importDefault(require("./generateTemplateFiles"));
const parseAppConfig_1 = __importDefault(require("./parseAppConfig"));
const info_1 = __importDefault(require("../utils/info"));
const generateAppFiles = (appName, app) => {
    const { routes, routingType, destinationDir, routeLinkOptions, importGenerateUrl, importRedirectServerSide } = parseAppConfig_1.default(appName, app);
    if (destinationDir) {
        const files = Object.entries(routes).map(([routeName, routePattern]) => generateTemplateFiles_1.default({
            routeName,
            routeLinkOptions,
            routePattern,
            destinationDir,
            routingType,
            importGenerateUrl,
            importRedirectServerSide,
        }));
        const filesToGenerate = files.flat();
        if (filesToGenerate.length > 0) {
            info_1.default([appName], `*** Generating files ***\n${filesToGenerate.map((file) => `${file.destinationDir}${file.filename}${file.extension}`).join("\n")}\n`);
        }
        else {
            info_1.default([appName], `*** No files to generate ***\n`);
        }
        return filesToGenerate;
    }
    info_1.default([appName], `*** No destinationDir. Not generating files ***\n`);
    return [];
};
exports.default = generateAppFiles;
//# sourceMappingURL=generateAppFiles.js.map