"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const printImport_1 = __importDefault(require("../../utils/printImport"));
const throwError_1 = __importDefault(require("../../utils/throwError"));
const generateUseRedirectFileNextJS = (params) => {
    const { routeName, patternNamedExports: { patternName, pathParamsInterfaceName, filename: routePatternFilename, urlPartsInterfaceName, patternNameNextJS, possiblePathParamsVariableName, }, destinationDir, importGenerateUrl, } = params;
    if (!patternNameNextJS) {
        return throwError_1.default([], 'Missing "patternNameNextJS". This is most likely a problem with route-codegen.');
    }
    const functionName = `useRedirect${routeName}`;
    const pathVariable = pathParamsInterfaceName ? "urlParts.path" : "{}";
    const resultTypeInterface = `RedirectFn${routeName}`;
    let namedImportsFromPatternFile = [{ name: patternName }, { name: urlPartsInterfaceName }, { name: patternNameNextJS }];
    let routerTemplate = `Router.push(${patternNameNextJS}, to);`;
    if (possiblePathParamsVariableName) {
        namedImportsFromPatternFile.push({ name: possiblePathParamsVariableName });
        routerTemplate = `const url = ${possiblePathParamsVariableName}.filter((key) => !(key in urlParts.path)).reduce((prevPattern, suppliedParam) => prevPattern.replace(\`/[${"${suppliedParam"}}]\`, ""), ${patternNameNextJS});
      Router.push(url, to);`;
    }
    const template = `${printImport_1.default({ defaultImport: "Router", from: "next/router" })}
  ${printImport_1.default({ namedImports: namedImportsFromPatternFile, from: `./${routePatternFilename}` })}
  ${printImport_1.default(importGenerateUrl)}
  export type ${resultTypeInterface} = (urlParts${!pathParamsInterfaceName ? "?" : ""}: ${urlPartsInterfaceName}) => void;
  const ${functionName} = (): ${resultTypeInterface} => {
    const redirect: ${resultTypeInterface} = urlParts => {
      const to = generateUrl(${patternName}, ${pathVariable}, urlParts?.urlQuery);
      ${routerTemplate}
    }
    return redirect;
  }
  export default ${functionName}`;
    const templateFile = {
        template,
        filename: functionName,
        extension: ".ts",
        destinationDir,
    };
    return templateFile;
};
exports.default = generateUseRedirectFileNextJS;
//# sourceMappingURL=generateUseRedirectFileNextJS.js.map